class CreateRecentFilters < ActiveRecord::Migration[5.0]
  def change
    create_table :recent_filters do |t|
      t.integer :user_id
      t.json :filters
      t.string :source
      t.string:filters_hash, limit: 64


      t.timestamps
    end

    add_index :recent_filters, [:user_id,:filters_hash,:source], unique: true, name: "index_recent_filters_on_user_filters_source"

    add_foreign_key :recent_filters, :users, column: :user_id, on_delete: :cascade, name: "fk_recent_filters_user"
  end
end
